--SYS:
队列
select  * from dba_queues   q  where  q.QUEUE_TYPE='NORMAL_QUEUE' ;
select  * from dba_queues q where q.QUEUE_TYPE='EXCEPTION_QUEUE';
select  * from dba_queues q where q.QUEUE_TYPE   not in ('NORMAL_QUEUE','EXCEPTION_QUEUE');

类型
CREATE OR REPLACE TYPE t_event_queue_payload AS OBJECT (
  event_name  VARCHAR2(30)
);
grant execute on t_event_queue_payload to hr;

需要AQ_ADMINISTRATOR_ROLE 
BEGIN
  -- Create a queue table to hold the event queue.
  DBMS_AQADM.create_queue_table(
    queue_table        => 'event_queue_tab',
    queue_payload_type => 't_event_queue_payload',
    multiple_consumers => TRUE,
    comment            => 'Queue Table For Event Messages');
  -- Create the event queue.
  DBMS_AQADM.create_queue (
    queue_name  => 'event_queue',
    queue_table => 'event_queue_tab');
  -- Start the event queue.
  DBMS_AQADM.start_queue (queue_name => 'event_queue');
END;

select  * from dba_queues   q  where  q.QUEUE_TYPE='NORMAL_QUEUE' ;
select  * from dba_queues q where q.QUEUE_TYPE='EXCEPTION_QUEUE';
select  * from dba_queues q where q.QUEUE_TYPE   not in ('NORMAL_QUEUE','EXCEPTION_QUEUE');

begin
   dbms_aqadm.grant_queue_privilege(privilege => 'ENQUEUE',queue_name => 'event_queue',grantee => 'HR');
end;
    
begin
   dbms_aqadm.grant_queue_privilege(privilege => 'DEQUEUE',queue_name => 'event_queue',grantee => 'HR');
end;

select  * from dba_tab_privs p  where p.grantee='HR';
grant execute on dbms_aq to hr;
grant create job to hr;

--HR:
DROP TABLE scheduler_test;
DROP SEQUENCE scheduler_test_seq;
CREATE TABLE scheduler_test (
  id            NUMBER(10)    NOT NULL,
  created_date  DATE          NOT NULL,
  CONSTRAINT scheduler_test_pk PRIMARY KEY (id)
);

select  * from scheduler_test;
CREATE SEQUENCE scheduler_test_seq;

/*
2.2 create_event_schedule
创建基于事件的调度，用于当一个特殊事件被抛出时启动一个job。
Event类型     描述
job_started   job启动
job_succeeded job启动成功
job_failed    job失败
job_broken    被禁止或状态改为broken
job_completed job执行完成即完成了限制的最大执行次数或者到达执行指定的结束时间
job_stopped   停止job
job_sch_lim_reached 达到了scheduler的限制设置的值
job_disabled    禁止job
job_chain_stalled  A job running a chain was put into the CHAIN_STALLED state. A running chain becomes
                   stalled if there are no steps running or scheduled to run and the chain evaluation_interval is set to NULL.
                   No progress will be made in the chain unless there is manual intervention.
job_all_events Not an event, but a constant that provides an easy way for you to enable all events
job_run_completed job执行或者失败或者成功或者被停止

参数：
event_condition——tab.user_data
queue_spec——必须先创建一个queue，dbms_aqadm.create_queue
*/

BEGIN
   DBMS_SCHEDULER.create_job (
      job_name        => 'job4',
      job_type        => 'PLSQL_BLOCK',
      job_action      => 'BEGIN
                            INSERT INTO scheduler_test (id, created_date)
                            VALUES (scheduler_test_seq.NEXTVAL, SYSDATE);
                            COMMIT;
                          END;',
      start_date      => SYSTIMESTAMP,
      event_condition => 'tab.user_data.event_name = ''give_me_a_prod''',
      queue_spec      => 'event_queue',
      enabled         => TRUE);
END;

DECLARE
  l_enqueue_options     DBMS_AQ.enqueue_options_t;
  l_message_properties  DBMS_AQ.message_properties_t;
  l_message_handle      RAW(16);
  l_queue_msg           sys.t_event_queue_payload;
BEGIN
  l_queue_msg := sys.t_event_queue_payload('give_me_a_prod');

  DBMS_AQ.enqueue(queue_name          => 'sys.event_queue',
                  enqueue_options     => l_enqueue_options,
                  message_properties  => l_message_properties,
                  payload             => l_queue_msg,
                  msgid               => l_message_handle);
  COMMIT;
END;

SELECT * FROM scheduler_test order by id;

/*
SELECT * FROM scheduler_test;

-- Remove the job.
EXEC DBMS_SCHEDULER.drop_job('event_based_job');
  
-- Stop the event queue.
EXEC DBMS_AQADM.stop_queue (queue_name => 'event_queue');

-- Drop the event queue.
EXEC DBMS_AQADM.drop_queue (queue_name => 'event_queue');

-- Remove the queue table.
EXEC DBMS_AQADM.drop_queue_table(queue_table => 'event_queue_tab');

DROP TYPE t_event_queue_payload;
DROP TABLE scheduler_test;
DROP SEQUENCE scheduler_test_seq;
PURGE RECYCLEBIN;
*/
